import { Injectable, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { createClient } from 'contentful';
var Config = (function () {
    function Config() {
    }
    return Config;
}());
var ContentfulService = (function () {
    /**
     * @param {?} config
     */
    function ContentfulService(config) {
        this.config = config;
        this.entries = {};
        this.entry = {};
        this.createClient(config);
    }
    /**
     * @param {?} params
     * @return {?}
     */
    ContentfulService.prototype.createClient = function (params) {
        this.client = createClient(params);
    };
    /**
     * @param {?=} query
     * @return {?}
     */
    ContentfulService.prototype.getEntries = function (query) {
        var /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entries[key]) {
            this.entries[key] = this.client.getEntries(query);
        }
        return this.entries[key];
    };
    /**
     * @param {?} id
     * @param {?=} query
     * @return {?}
     */
    ContentfulService.prototype.getEntry = function (id, query) {
        var /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entry[key]) {
            this.entry[key] = this.client.getEntry(id, query);
        }
        return this.entry[key];
    };
    return ContentfulService;
}());
ContentfulService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ContentfulService.ctorParameters = function () { return [
    { type: Config, },
]; };
var ContentfulModule = (function () {
    function ContentfulModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    ContentfulModule.forRoot = function (config) {
        return {
            ngModule: ContentfulModule,
            providers: [
                { provide: Config, useValue: config }
            ]
        };
    };
    return ContentfulModule;
}());
ContentfulModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: [],
                providers: [ContentfulService]
            },] },
];
/**
 * @nocollapse
 */
ContentfulModule.ctorParameters = function () { return []; };
/**
 * Generated bundle index. Do not edit.
 */
export { ContentfulService, ContentfulModule, Config as ɵa };
//# sourceMappingURL=angular-contentful-service.es5.js.map
