import { Injectable, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { createClient } from 'contentful';

class Config {
}

class ContentfulService {
    /**
     * @param {?} config
     */
    constructor(config) {
        this.config = config;
        this.entries = {};
        this.entry = {};
        this.createClient(config);
    }
    /**
     * @param {?} params
     * @return {?}
     */
    createClient(params) {
        this.client = createClient(params);
    }
    /**
     * @param {?=} query
     * @return {?}
     */
    getEntries(query) {
        let /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entries[key]) {
            this.entries[key] = this.client.getEntries(query);
        }
        return this.entries[key];
    }
    /**
     * @param {?} id
     * @param {?=} query
     * @return {?}
     */
    getEntry(id, query) {
        let /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entry[key]) {
            this.entry[key] = this.client.getEntry(id, query);
        }
        return this.entry[key];
    }
}
ContentfulService.decorators = [
    { type: Injectable },
];
/**
 * @nocollapse
 */
ContentfulService.ctorParameters = () => [
    { type: Config, },
];

class ContentfulModule {
    /**
     * @param {?} config
     * @return {?}
     */
    static forRoot(config) {
        return {
            ngModule: ContentfulModule,
            providers: [
                { provide: Config, useValue: config }
            ]
        };
    }
}
ContentfulModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule
                ],
                declarations: [],
                providers: [ContentfulService]
            },] },
];
/**
 * @nocollapse
 */
ContentfulModule.ctorParameters = () => [];

/**
 * Generated bundle index. Do not edit.
 */

export { ContentfulService, ContentfulModule, Config as ɵa };
//# sourceMappingURL=angular-contentful-service.js.map
