(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('contentful')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'contentful'], factory) :
	(factory((global['angular-contentful-service'] = {}),global.ng.core,global.ng.common,global.contentful));
}(this, (function (exports,core,common,contentful) { 'use strict';

var Config = (function () {
    function Config() {
    }
    return Config;
}());
var ContentfulService = (function () {
    /**
     * @param {?} config
     */
    function ContentfulService(config) {
        this.config = config;
        this.entries = {};
        this.entry = {};
        this.createClient(config);
    }
    /**
     * @param {?} params
     * @return {?}
     */
    ContentfulService.prototype.createClient = function (params) {
        this.client = contentful.createClient(params);
    };
    /**
     * @param {?=} query
     * @return {?}
     */
    ContentfulService.prototype.getEntries = function (query) {
        var /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entries[key]) {
            this.entries[key] = this.client.getEntries(query);
        }
        return this.entries[key];
    };
    /**
     * @param {?} id
     * @param {?=} query
     * @return {?}
     */
    ContentfulService.prototype.getEntry = function (id, query) {
        var /** @type {?} */ key;
        key = query ? JSON.stringify(query) : 'no-query';
        // Cache promise for future use
        if (!this.entry[key]) {
            this.entry[key] = this.client.getEntry(id, query);
        }
        return this.entry[key];
    };
    return ContentfulService;
}());
ContentfulService.decorators = [
    { type: core.Injectable },
];
/**
 * @nocollapse
 */
ContentfulService.ctorParameters = function () { return [
    { type: Config, },
]; };
var ContentfulModule = (function () {
    function ContentfulModule() {
    }
    /**
     * @param {?} config
     * @return {?}
     */
    ContentfulModule.forRoot = function (config) {
        return {
            ngModule: ContentfulModule,
            providers: [
                { provide: Config, useValue: config }
            ]
        };
    };
    return ContentfulModule;
}());
ContentfulModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [],
                providers: [ContentfulService]
            },] },
];
/**
 * @nocollapse
 */
ContentfulModule.ctorParameters = function () { return []; };

exports.ContentfulService = ContentfulService;
exports.ContentfulModule = ContentfulModule;
exports.ɵa = Config;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-contentful-service.umd.js.map
